CREATE OR REPLACE FUNCTION public.copy_map(withukd integer, withoutukd integer)
  RETURNS integer
LANGUAGE plpgsql
AS $function$
--declare maxrate1 int default -1; maxrate2 int default -1; examtype1 exam_credit_grading_credit default null; examtype2 exam_credit_grading_credit default null;
declare newid int default -1; keyid int default -1;
    crsModules cursor for select modules.id, modules."name", modules.ordernum, modules."type"
                          from modules
                          where modules.disciplineid=withukd and modules.ordernum!=3141592 and modules.ordernum!=2900666; -- exam and extra
    crsSubmodules cursor for select submodules.maxrate, submodules.ordernum, submodules."name", submodules.description, submodules.isused, submodules."type"
                             from submodules
                             where submodules.moduleid=keyid;

begin
  /*    select maxrate, examtype into maxrate1, examtype1
      from disciplines where id=withukd;
      select maxrate, examtype into maxrate2, examtype2
      from disciplines where id=withoutukd;
  */
  --if (maxrate1=100 and maxrate2!=100 and examtype1=examtype2 and examtype1 is not null) then
  for mdl in crsModules loop
    keyid=mdl.id;
    insert into modules("name", ordernum, disciplineid, "type")
    values(mdl."name", mdl.ordernum, withoutukd, mdl."type") returning id into newid;
    for sbmdl in crsSubmodules loop
      insert into submodules(moduleid, maxrate, ordernum, "name", description, isused, "type")
      values(newid, sbmdl.maxrate, sbmdl.ordernum, sbmdl."name", sbmdl.description, sbmdl.isused, sbmdl."type");
    end loop;
  end loop;
  return 0;
  --end if;
  return -1;
end
$function$;


DROP FUNCTION IF EXISTS public.teacher_getsimilardisciplines(pid integer, psubjectid integer);
DROP FUNCTION IF EXISTS public.teacher_getsimilardisciplines(pid integer, psubjectid integer, psemesterid integer);
CREATE OR REPLACE FUNCTION public.teacher_getsimilardisciplines(pid integer, psubjectid integer, psemesterid integer)
  RETURNS TABLE("ID" integer, "SemesterID" integer, "SubjectName" character varying, "ExamType" exam_credit_grading_credit)
LANGUAGE plpgsql
AS $function$
begin
  --select * from public.teacher_getsimilardisciplines(
  --	:pid,	-- put the pid parameter value instead of 'pid' (int4)
  --	:psubjectid 	-- put the psubjectid parameter value instead of 'psubjectid' (int4)
  --);

  if psemesterid is null and psubjectid is null then
    return query
    SELECT  disciplines.ID			as "ID",
            disciplines.SemesterID  as "SemesterID",
            subjects.name as "SubjectName",
            disciplines.ExamType	as "ExamType"
    FROM disciplines_teachers
      JOIN disciplines ON disciplines_teachers.DisciplineID = disciplines.ID
      JOIN subjects ON disciplines.subjectid = subjects.id
    WHERE disciplines_teachers.TeacherID = pID AND
          disciplines.MaxRate = 100;
  elsif psemesterid is null then
    return query
    SELECT  disciplines.ID			as "ID",
            disciplines.SemesterID  as "SemesterID",
            subjects.name as "SubjectName",
            disciplines.ExamType	as "ExamType"
    FROM disciplines_teachers
      JOIN disciplines ON disciplines_teachers.DisciplineID = disciplines.ID
      JOIN subjects ON disciplines.subjectid = subjects.id
    WHERE disciplines_teachers.TeacherID = pID AND
          disciplines.SubjectID = pSubjectID AND
          disciplines.MaxRate = 100;
  elsif psubjectid is null then
    return query
    SELECT  disciplines.ID			as "ID",
            disciplines.SemesterID  as "SemesterID",
            subjects.name as "SubjectName",
            disciplines.ExamType	as "ExamType"
    FROM disciplines_teachers
      JOIN disciplines ON disciplines_teachers.DisciplineID = disciplines.ID
      JOIN subjects ON disciplines.subjectid = subjects.id
    WHERE disciplines_teachers.TeacherID = pID AND
          disciplines.MaxRate = 100 AND
          disciplines.semesterid = psemesterid;
  else
    return query
    SELECT  disciplines.ID			as "ID",
            disciplines.SemesterID  as "SemesterID",
            subjects.name as "SubjectName",
            disciplines.ExamType	as "ExamType"
    FROM disciplines_teachers
      JOIN disciplines ON disciplines_teachers.DisciplineID = disciplines.ID
      JOIN subjects ON disciplines.subjectid = subjects.id
    WHERE disciplines_teachers.TeacherID = pID AND
          disciplines.SubjectID = pSubjectID AND
          disciplines.MaxRate = 100 AND
          disciplines.semesterid = psemesterid;
  end if;
end;
$function$;

DROP FUNCTION IF EXISTS public.discipline_hasmap(pdisciplineid integer);
CREATE OR REPLACE FUNCTION public.discipline_hasmap(pdisciplineid integer)
  RETURNS integer
LANGUAGE plpgsql
AS $function$
DECLARE vCountModules INT DEFAULT 0;
begin
  select count(*) as cnt into vCountModules
  from disciplines
    join modules
      on disciplines.id = modules.disciplineid
  where disciplines.id = pdisciplineid and modules.type != 'extra' and modules.type != 'exam';
  return vCountModules;
end;
$function$;
