DROP FUNCTION IF EXISTS public.createrecoverytoken(paccountoremail character varying, ptoken character varying);
CREATE OR REPLACE FUNCTION public.createrecoverytoken(paccountoremail character varying, ptoken character varying)
  RETURNS character varying
LANGUAGE plpgsql
AS $function$
DECLARE vAccountID INT DEFAULT null;
  DECLARE vUserFullName TEXT;
BEGIN
  --select public.createrecoverytoken(
  --	:paccountoremail,	-- put the paccountoremail parameter value instead of 'paccountoremail' (varchar)
  --	:ptoken 	-- put the ptoken parameter value instead of 'ptoken' (varchar)
  --);
  -- get account ID
  SELECT accounts.ID INTO vAccountID
  FROM accounts
  WHERE accounts.EMail = pAccountOrEMail OR
        accounts.Login = pAccountOrEMail
  LIMIT 1;
  IF vAccountID is null THEN
    RETURN '';
  END IF;

  vUserFullName := GetUserFullNameByAccountID(vAccountID);
  IF vUserFullName IS NULL OR vUserFullName = '' THEN
    RETURN '';
  END IF;

  -- transform all unused recovery tokens into used
  UPDATE recovery_tokens
  SET isUsed = 1
  WHERE   isUsed = 0 AND
          AccountID = vAccountID;

  -- handle catch constraints violations
  INSERT INTO recovery_tokens
  ( AccountID, Token )
  VALUES  (vAccountID, pToken);
  RETURN vUserFullName;
  EXCEPTION
  when others then  RETURN -2; -- тип ???
END
$function$;
